#ifndef DIE_H
#define DIE_H

#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/macro_noreturn.h>

extern const char *PROGRAM;
extern const char USAGE[];

void	die_acquire(const char *dir, const char *fn) __NORETURN__;
void	die_append(const char *dir, const char *fn) __NORETURN__;
void	die_chdir(const char *dir) __NORETURN__;
void	die_child_crashed(const char *program) __NORETURN__;
void	die_chmod(const char *dir, const char *name) __NORETURN__;
void	die_create(const char *fn) __NORETURN__;
void	die_create_pipe(const char *fn) __NORETURN__;
void	die_env(const char *name) __NORETURN__;
void	die_exec(const char *fn) __NORETURN__;
void	die_exec2(const char *dir, const char *fn) __NORETURN__;
void	die_fork(void) __NORETURN__;
void	die_lock(const char *fn) __NORETURN__;
void	die_nomem(void) __NORETURN__;
void	die_open(const char *fn) __NORETURN__;
void	die_open2(const char *dir, const char *fn) __NORETURN__;
void	die_read(const char *fn) __NORETURN__;
void	die_read2(const char *dir, const char *fn) __NORETURN__;
void	die_setgid(gid_t gid) __NORETURN__;
void	die_setuid(uid_t uid) __NORETURN__;
void	die_stat(const char *dir, const char *fn) __NORETURN__;
void	die_supervise(const char *fn) __NORETURN__;
void	die_supervise2(const char *dir, const char *fn) __NORETURN__;
void	die_sys(const char *what) __NORETURN__;
void	die_unknown_account(const char *account) __NORETURN__;
void	die_usage(void) __NORETURN__;
void	die_usage1(const char *message) __NORETURN__;
void	die_wait(const char *program) __NORETURN__;
void	die_write(const char *fn) __NORETURN__;
void	die_write2(const char *dir, const char *fn) __NORETURN__;

extern const char _FATAL[];

#endif /* DIE_H */
