#include <sys/types.h>
#include <pwd.h>

#include <nemo/fmt.h>
#include <nemo/strerr.h>
#include <nemo/pathexec.h>

#include "die.h"

const char USAGE[] = "account child";

static char strnum[FMT_ULONG];
static const char *account;
static struct passwd *pw;

int main(int argc, char **argv)
{
  PROGRAM = argv[0];
  if (argc < 3) die_usage();
  account = *++argv;
  ++argv;

  pw = getpwnam(account);
  if (!pw) die_unknown_account(account);

  strnum[fmt_ulong(strnum, pw->pw_gid)] = 0;
  if (!pathexec_env("GID", strnum)) die_nomem();
  strnum[fmt_ulong(strnum, pw->pw_uid)] = 0;
  if (!pathexec_env("UID", strnum)) die_nomem();

  pathexec(argv);
  die_exec(*argv);
  return 0;  /* lint */
}
