#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/error.h>
#include <nemo/unix.h>
#include <nemo/exit.h>
#include <nemo/sig.h>
#include <nemo/macro_unused.h>

static char *buf;
static unsigned int len = 0;

static void sighup(int s __UNUSED__)
{
  register unsigned int i;
  for (i = 0; i < len; ++i) {
    buf[i] = '.';
  }
}

int main(int argc, char **argv)
{
  register unsigned int i;
  char ch;

  if (argc < 2) _exit(100);
  buf = argv[argc - 1];
  while (buf[len]) {
    buf[len++] = '.';
  }
  if (len < 5) _exit(100);

  sig_hangupcatch(sighup);
  for (;;) {
    switch (read(0, &ch, 1)) {
      case 1:
        if (ch) {
          for (i = 4; i < len; ++i) {
            buf[i - 1] = buf[i];
          }
          buf[len - 1] = ch;
        }
        break;
      case 0:
        _exit(0);
      case -1:
        if (errno != error_intr) _exit(111);
        break;
      default:
        break;
    }
  }
}
