#include <nemo/stdint.h>
#include <nemo/lock.h>
#include <nemo/open.h>
#include <nemo/strerr.h>
#include <nemo/pathexec.h>
#include <nemo/sgetopt.h>
#include <nemo/exit.h>

#include "die.h"

const char USAGE[] = "[ -nNxX ] file program [ arg ... ]";

static unsigned int flag_ndelay = 0;
static unsigned int flag_x = 0;

int main(int argc, char **argv, char **envp)
{
  int opt;
  int fd;
  const char *file;

  PROGRAM = argv[0];
  while ((opt = getopt(argc, argv, "nNxX")) != opteof) {
    switch(opt) {
      case 'n':
        flag_ndelay = 1;
        break;
      case 'N':
        flag_ndelay = 0;
        break;
      case 'x':
        flag_x = 1;
        break;
      case 'X':
        flag_x = 0;
        break;
      default:
        die_usage();
        break;
    }
  }

  argv += optind;
  if (!*argv) die_usage();
  file = *argv++;
  if (!*argv) die_usage();

  fd = open_append(file);
  if (fd < 0) {
    if (flag_x) _exit(0);
    die_open(file);
  }

  if ((flag_ndelay ? lock_exnb : lock_ex)(fd) < 0) {
    if (flag_x) _exit(0);
    die_lock(file);
  }

  pathexec_run(*argv, argv, envp);
  die_exec(*argv);
  return 0;  /* lint */
}
