#include <sys/types.h>
#include <pwd.h>

#include <nemo/prot.h>
#include <nemo/strerr.h>
#include <nemo/pathexec.h>

#include "die.h"

const char USAGE[] = "account child";

static const char *account;
struct passwd *pw;

int main(int argc, char **argv, char **envp)
{
  PROGRAM = argv[0];
  if (argc < 3) die_usage();
  account = *++argv;
  ++argv;

  pw = getpwnam(account);
  if (!pw) die_unknown_account(account);

  if (prot_gid(pw->pw_gid) < 0) die_setgid(pw->pw_gid);
  if (prot_uid(pw->pw_uid) < 0) die_setuid(pw->pw_uid);

  pathexec_run(*argv, argv, envp);
  die_exec(*argv);
  return 0;  /* lint */
}
