#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/strerr.h>
#include <nemo/error.h>
#include <nemo/open.h>
#include <nemo/unix.h>
#include <nemo/exit.h>

#include "die.h"

const char USAGE[] = "dir";
const char SUPERVISE_OK[] = "supervise/ok";

int main(int argc, char **argv)
{
  char *dir;
  int fd;

  PROGRAM = argv[0];
  if (argc != 2) die_usage();
  dir = argv[1];

  if (chdir(dir) < 0) die_chdir(dir);

  fd = open_write(SUPERVISE_OK);
  if (fd < 0) {
    if (errno == error_noent) _exit(100);
    if (errno == error_nodevice) _exit(100);
    die_open2(dir, SUPERVISE_OK);
  }

  _exit(0);
}
