#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/exit.h>
#include <nemo/tai.h>
#include <nemo/taia.h>
#include <nemo/unix.h>
#include <nemo/macro_unused.h>

static ssize_t mywrite(int fd, const void *buf, size_t len)
{
  ssize_t w;
  w = write(fd, buf, len);
  if (w < 0) _exit(111);
  return w;
}

static char outbuf[2048];
static djbio out = DJBIO_INITWRITE(mywrite, 1, outbuf, sizeof outbuf);

static ssize_t myread(int fd, void *buf, size_t len)
{
  ssize_t r;
  djbio_flush(&out);
  r = read(fd, buf, len);
  if (r < 0) _exit(111);
  return r;
}

static char inbuf[1024];
static djbio in = DJBIO_INITREAD(myread, 0, inbuf, sizeof inbuf);

static char stamp[TAIA_TIMESTAMP];

int main(int argc __UNUSED__, char **argv __UNUSED__)
{
  byte_t ch;
  for (;;) {
    if (djbio_GETC(&in, &ch) != 1) _exit(0);
    taia_timestamp(stamp);
    stamp[TAIA_TIMESTAMP - 1] = ' ';
    djbio_put(&out, stamp, TAIA_TIMESTAMP);
    for (;;) {
      djbio_PUTC(&out, ch);
      if (ch == '\n') break;
      if (djbio_GETC(&in, &ch) != 1) _exit(0);
    }
  }
}
